VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5415
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7905
   LinkTopic       =   "Form1"
   ScaleHeight     =   5415
   ScaleWidth      =   7905
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   375
      Left            =   120
      TabIndex        =   1
      Top             =   4920
      Width           =   1815
   End
   Begin VB.TextBox Text1 
      Height          =   4695
      Left            =   120
      MultiLine       =   -1  'True
      TabIndex        =   0
      Text            =   "test=1*1+(1+2-1)*(3*1+2)-(-4)+-2^2+LOG(10,SQR(8+1)) ;=21.0959"
      Top             =   120
      Width           =   7695
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Const OpEqual As String = "="
Const OpGT As String = ">"
Const OpGE As String = ">="
Const OpLT As String = "<"
Const OpLE As String = "<="
Const OpEQ As String = "="
Const OpNE As String = "<>"
Const MarkRemarks As String = ";"
Const MarkAccount As String = "&"
Const MarkCondition As String = "#"
Const MarkLine As String = ","

Private Type VariableType
  Name As String
  Value As Currency
End Type
Dim aVariables() As VariableType

Private WithEvents objCalcTree As CalcTree
Attribute objCalcTree.VB_VarHelpID = -1

Function SetVariableValue(Variable As String, Value As Currency) As Boolean
Dim I As Long, I0 As Long
For I = 1 To UBound(aVariables)
  If UCase$(aVariables(I).Name) = UCase$(Variable) Then
    I0 = I
    Exit For
  End If
Next I
If I0 = 0 Then
  I0 = UBound(aVariables) + 1
  ReDim Preserve aVariables(0 To I0)
  aVariables(I0).Name = Variable
  SetVariableValue = True
End If
aVariables(I0).Value = Value
End Function

Function GetVariableValue(Variable As String) As Currency
Dim I As Long
For I = 1 To UBound(aVariables)
  If UCase$(aVariables(I).Name) = UCase$(Variable) Then
    GetVariableValue = aVariables(I).Value
    Exit For
  End If
Next I
End Function

Function GetAccountValue(Account As String) As Currency
GetAccountValue = 12
End Function

Function GetValue(Expression As String) As Currency
Dim fMinus As Boolean, V As String
If Left$(Expression, 1) = "-" Then
  fMinus = True
  V = Mid$(Expression, 2)
Else
  fMinus = False
  V = Expression
End If
If Left$(V, Len(V)) = MarkAccount Then
  GetValue = GetAccountValue(V)
ElseIf IsNumeric(V) Then
  GetValue = CCur(V)
Else
  GetValue = GetVariableValue(V)
End If
If fMinus Then GetValue = -GetValue
End Function

Function CheckExpression(Expression As String) As Boolean
CheckExpression = True
End Function

Function ParseLine(Expression As String) As Boolean
If Len(Expression) = 0 Then Exit Function
Dim F As String, S As String, V As Currency, I As Long
I = InStr(Expression, OpEqual)
If I = 0 Then Exit Function
F = Left$(Expression, I - 1)
S = Mid$(Expression, I + Len(OpEqual))
objCalcTree.Expression = S
V = objCalcTree.Result
SetVariableValue F, V
Debug.Print F & " = " & V
If objCalcTree.ErrorState Then Debug.Print "ERROR: " & objCalcTree.Error
End Function

Sub ParseString(Expression As String)
Dim I0 As Long, I As Long, S As String, L As String, P0 As Long, P1 As Long, P2 As Long
ReDim aVariables(0)
I0 = 1
Do While I0 <= Len(Expression)
  I = InStr(I0, Expression, vbNewLine)
  If I = 0 Then I = Len(Expression) + 1
  S = Mid$(Expression, I0, I - I0)
  If Right$(RTrim$(S), Len(MarkLine)) = MarkLine Then
    If InStr(S, MarkRemarks) > 0 Then S = Left$(S, InStr(S, MarkRemarks) - 1)
    S = Replace$(S, " ", vbNullString)
    L = L & Left$(S, InStrRev(S, MarkLine) - 1)
  Else
    If InStr(S, MarkRemarks) > 0 Then S = Left$(S, InStr(S, MarkRemarks) - 1)
    If UCase$(Left$(LTrim$(S), 4)) = MarkCondition & "IF " Then
      I = InStr(I0 + 1, Expression, MarkCondition & "ENDIF", vbTextCompare)
      If I = 0 Then I = Len(Expression) + 1
      P1 = InStr(I0, Expression, MarkCondition & "IF", vbTextCompare)
      P2 = InStr(P1, Expression, MarkCondition & "THEN", vbTextCompare)
      P0 = P2 + Len(MarkCondition & "THEN")
      S = Mid$(Expression, P1 + Len(MarkCondition & "IF"), P2 - (P1 + Len(MarkCondition & "IF")))
      If CheckExpression(Replace$(S, " ", vbNullString)) Then
        P1 = InStr(P0, Expression, MarkCondition & "ELSE", vbTextCompare)
        If P1 < I And P1 > 0 Then
          L = Mid$(Expression, P0, P1 - P0)
        Else
          L = Mid$(Expression, P0, I - P0)
        End If
      Else
        P1 = InStr(P0, Expression, MarkCondition & "ELSE", vbTextCompare)
        If P1 < I And P1 > 0 Then
          P1 = P1 + Len(MarkCondition & "ELSE")
          L = Mid$(Expression, P1, I - P1)
        Else
          L = vbNullString
        End If
      End If
      ParseString L
      I = I - Len(vbNewLine) + Len(MarkCondition & "ENDIF")
      L = vbNullString
    Else
      S = Replace$(S, " ", vbNullString)
      L = L & S
      If Len(L) > 0 Then
        Call ParseLine(L)
        L = vbNullString
      End If
    End If
  End If
  I0 = I + Len(vbNewLine)
Loop
End Sub

Private Sub Command1_Click()
ParseString Text1.Text
End Sub

Private Sub Form_Load()
Set objCalcTree = New CalcTree
End Sub

Private Sub Form_Unload(Cancel As Integer)
Set objCalcTree = Nothing
End Sub

Private Sub objCalcTree_RequestData(Field As String, Value As Variant)
If UCase$(Field) = "PI" Then
  Value = 3.14159265358979
  Exit Sub
End If
Value = GetValue(Field)
End Sub

Private Sub objCalcTree_RequestFunction(Name As String, Result As Variant, Arguments() As Variant)
Select Case UCase$(Name)
  Case "LOG"
    Result = Log(Arguments(1)) / Log(Arguments(2))
  Case "SQR"
    Result = Sqr(Arguments(1))
  Case "PI"
    Result = 3.14159265358979
End Select
End Sub
